<template>
  <div class="flex items-center col-grow">
    <q-btn
      round
      icon="drag_handle"
      class="filter__drag-handle q-mr-sm"
      size="xs"
    />
    <q-select
      v-model="filter.config.field"
      :disable="availableFields.length === 0"
      stack-label="Field"
      :options="availableFields"
      inverted-light
      color="white"
    />
    <q-input
      v-model="filter.label"
      stack-label="Label"
      inverted-light
      color="white"
      class="q-ml-sm col-grow"
    />
    <q-input
      v-model="filter.width"
      stack-label="Width"
      inverted-light
      color="white"
      type="number"
      :min="0"
      :max="100"
      class="q-ml-sm"
    />
    <q-select
      v-model="filter.type"
      stack-label="Type"
      inverted-light
      color="white"
      class="q-ml-sm"
      :options="availableTypes"
    />
    <q-btn
      icon="build"
      round
      color="blue"
      class="q-ml-sm"
      @click="edit"
      :disable="!filter.type"
    />
    <q-btn
      icon="delete"
      round
      color="red"
      class="q-ml-sm"
      @click="remove"
    />
  </div>
</template>

<script>
  import {
    availableCollectionEditorFieldTypes,
  } from '../../../../../../utilities/migrateConfig';
  import commonField from '../../../../../../utilities/defaults/commonField';

  export default {
    name: 'collectionFilter',
    props: {
      filter: {
        type: Object,
      },
      availableFields: {
        type: Array,
      },
    },
    methods: {
      edit() {
        this.$emit('edit');
      },
      remove() {
        this.$emit('remove');
      },
    },
    watch: {
      // eslint-disable-next-line func-names
      'filter.type': function (type) {
        this.filter.config = { field: this.filter.config.field || null, ...commonField(type) };
      },
      // eslint-disable-next-line func-names
      'filter.config.field': function (field, oldField) {
        if (this.filter.label === oldField || !this.filter.label) {
          this.filter.label = field;
        }
      },
    },
    data() {
      return {
        availableWidthUnits: ['px', '%'].map((value) => ({
          value,
          label: value,
        })),
        availableTypes: availableCollectionEditorFieldTypes,
      };
    },
  };
</script>

<style scoped>

</style>
